"""json

Revision ID: e3312a5fe305
Revises: 09cfd21b8ca0
Create Date: 2021-12-23 12:46:01.496614+01:00

"""
import json
import sqlalchemy as sa
from alembic import op
from app.db import models
from sqlalchemy import text

# revision identifiers, used by Alembic.
revision = "e3312a5fe305"
down_revision = "09cfd21b8ca0"
branch_labels = None
depends_on = None


def upgrade():
    """Upgrade"""

    # ### commands auto generated by Alembic - please adjust! ###

    #  Two missing indexes where generated
    op.create_index(op.f("ix_formStorage_id"), "formStorage", ["id"], unique=False)
    op.create_index(op.f("ix_formStorage_sid"), "formStorage", ["sid"], unique=False)

    # Rename some columns so they meet the naming conventions
    op.alter_column(
        table_name="request",
        column_name="registrationDate",
        new_column_name="registration_date",
    )
    op.alter_column(
        table_name="request",
        column_name="formUuid",
        new_column_name="form_uuid",
    )

    # Change the type of formInput
    connection = op.get_bind()
    results = connection.execute(
        text('select request.sid, request."formInput" from request')
    ).fetchall()

    converted_values: list[dict] = []
    for sid, formInput in results:
        converted_values.append(
            {
                "sid": sid,
                "form_input": json.loads(formInput) if formInput else None,
            }
        )

    op.drop_column(table_name="request", column_name="formInput")

    op.add_column("request", sa.Column("form_input", sa.JSON()))

    for item in converted_values:
        connection.execute(
            sa.update(models.Request)
            .where(models.Request.sid == item["sid"])
            .values(form_input=item["form_input"])
        )

    # ### end Alembic commands ###


def downgrade():
    """Downgrade"""
    # ### commands auto generated by Alembic - please adjust! ###
    pass
    # ### end Alembic commands ###
